-- MH-Z19B calibrate
do
local RAW = {}
local clb = ''
local kt, exit, ans, calibr, ustart
ustart = false
kt= tmr.create()

exit = function(kl)
	uart.on(2, "data")
	table.foreach(RAW, print)
	if kt then kt:stop(); kt:unregister(); kt = nil end
	tmrwork:start()
	if not kl then print('UART Killed!') end
	print('Calibrated at '..clb)
	if #RAW > 0 then
		ans = ''
		for _, v in ipairs(RAW) do
			ans = ans..string.format("0x%02X", v)..', '
		end
		print(ans)
		if m and dat and dat.broker == true then
			m:publish(dat.clnt..'/answer', ans, 2, 0) 
		end
	end
end
kt:register(10000, tmr.ALARM_SINGLE, exit)

calibr = function(com)
	uart.on(2, "data",1,
	    function(data)
	    	if ustart == false and string.byte(data, 1) ~= 255	then 
	    		return
	    	elseif ustart == false then 
	    		ustart = true
	    	end
	    	RAW[#RAW+1] = string.byte(data, 1)
	    	if #RAW == 9 then exit(true) end
	    end, 0)
	if clb == 'ZERO' then
		uart.write(2,255,1,135,0,0,0,0,0,120) -- Zero clb
	elseif clb == 'ABCOFF' then
		uart.write(2,255,1,121,0,0,0,0,0,134) -- ABC off
	elseif clb == 'ABCON' then
		uart.write(2,255,1,121,160,0,0,0,0,230) -- ABC on
	elseif clb == 'RNG2' then
		uart.write(2,0x00, 0xFF, 0x01, 0x99, 0x00, 0x00, 0x00, 0x07, 0xD0, 0x8F) -- 0 - 2000
	elseif clb == 'RNG5' then
		uart.write(2,0x00, 0xFF, 0x01, 0x99, 0x00, 0x00, 0x00, 0x07, 0xD0, 0x8F) -- 0 - 5000
	end
end
kt:start()
return function(com)
	tmrwork:stop()
	clb = com
	tmr.create():alarm(4000, tmr.ALARM_SINGLE,calibr)
end
end