do
    if not dat then dat = {}; dat.clnt = 'test' end
    dat.brk = 'iot.eclipse.org'
    dat.port = 1883
    local subscribe, merror, newm, mconnect

    function subscribe(con)
        print("connected")
        dat.broker = true
        con:subscribe(dat.clnt.."/com/#", 0)
        con:publish(dat.clnt..'/state', "ON", 0, 1)
        print("Subscribed")
    end

    function merror(con)
        con = nil
        m = nil
        tmr.create():alarm(30000, tmr.ALARM_SINGLE, function() mconnect(newm()) end)
    end

    function newm()
        m = mqtt.Client(dat.clnt, 25, dat.clnt, 'pass22')
        m:lwt(dat.clnt..'/state', "OFF", 0, 1)
        m:on("offline", function(con)
            con:close()
            dat.broker = false
            print("offline")
            merror(con)
        end)
        m:on("message", function(con, top, dt)
            if not killtop then killtop = {} end
            top = string.match(top, "/(%w+)$")
            print('Got', top, dt)
            if dt then
                table.insert(killtop, {top, dt})
                if not dat.analiz then
                    dofile("mqttanalize.lua")
                end
            end
        end)
        return m
    end

    function mconnect(con)
        con:connect(dat.brk, dat.port, 0, 0, subscribe, merror)
    end
    mconnect(newm())

end
