dat = {}
wifi.start()
wifi.sta.on("disconnected", function(ev, info)
  print("Lost WiFi!")
  dat.wifi = nil
end)
wifi.sta.on("got_ip", function(ev, info)
  dat.wifi = true
  print("NodeMCU Got IP:", info.ip)
end)

time.settimezone('EST-3')
time.initntp()

local runfile = "setglobals.lua"
print("Try Run ", runfile)
tmr.create():alarm(10000, 0, function()
	if runfile and file.exists(runfile) then
		dofile(runfile)
	else
		print("No runfile! Start IDE")
		if file.exists('ide.lua') then
			rtcmem.write32(0, 501)
			node.restart()
		else
			print('Stop, No IDE!')
		end
	end
end)
